#ifndef _BUTTON_H_
#define _BUTTON_H_

//#define BUTTON_DEBUG
#define MAX_NUM_OF_BUTTONS 1

#define BUTTON_IS_PRESSED	GPIO_PIN_SET
#define BUTTON_LONGPRESS_IN_MS	3000
#define BUTTON_DOUBLECLICK_WAIT_IN_MS 300


typedef enum
{
	BUTTON_NONE = 0x00,   	/* LONG Press */
	BUTTON_LONGPRESS = 0x01,   	/* LONG Press */
	BUTTON_DOUBLE_CLICK = 0x02,   	/* Signal Fixed */
	BUTTON_CLICK = 0x03,   	/* Signal Fixed */
	BUTTON_LONGPRESS_DETECTED = 0x04,
} BUTTONPress_TypeDef;

typedef enum
{
	BUTTON_WAIT_TO_PRESS = 0x00,
	BUTTON_WAIT_TO_LONGPRESS = 0x01,
	BUTTON_WAIT_TO_CLICK = 0x02,
	BUTTON_WAIT_TO_DOUBLECLICK = 0x03,
	BUTTON_WAIT_TO_RELEASE = 0x6,
} BUTTONMode_TypeDef;

typedef struct
{
	GPIO_TypeDef* GPIO_Port;
	uint16_t GPIO_Pin;
	uint16_t Timer;
	BUTTONMode_TypeDef State;
	BUTTONPress_TypeDef Press;
} BUTTONInfo_TypeDef;

extern BUTTONInfo_TypeDef BUTTON[MAX_NUM_OF_BUTTONS];
void BUTTON_Init(GPIO_TypeDef* GPIOx, uint16_t GPIO_Pin, uint8_t button);
BUTTONPress_TypeDef BUTTON_KeyPressed(uint8_t button);
void BUTTON_Handler(void);
void BUTTON_TimerHandler(void);

#endif
