#include "main.h"
#include "stm32l4xx_hal.h"
#include "led.h"

LEDInfo_TypeDef LED[MAX_NUM_OF_LEDS];
#define SETLED(led,val) HAL_GPIO_WritePin(LED[led].GPIO_Port, LED[led].GPIO_Pin, ~val)
uint16_t LED_Timer = 0;

void LED_Init(GPIO_TypeDef* GPIOx, uint16_t GPIO_Pin, uint8_t led)
{
	if (led >= MAX_NUM_OF_LEDS) return;
	LED[led].GPIO_Port = GPIOx;
	LED[led].GPIO_Pin = GPIO_Pin;
	LED[led].Timer = 0;
	LED[led].State = 0;
}

void LED_SetState(uint8_t led, uint16_t state)
{
	LED[led].State = state;
}

void LED_Handler(void)
{
	if (LED_Timer != LED_BIT_PERIOD_IN_MS)
	{
		LED_Timer++;
		return;
	}
	LED_Timer = 0;
	for (uint8_t i = 0; i < MAX_NUM_OF_LEDS; i++)
	{
		SETLED(i, LED[i].State&1);
		LED[i].State >>= 1;
	}
}
